#ifndef DIVIDING_H
#define DIVIDING_H

#define dividing_into_fields                 dividing_P_Z_S_int_B
#define dividing_into_few_fields             dividing_P_Z_S_char_B
#define full_house_dividing_into_fields      dividing_Z_S_int_B
#define full_house_dividing_into_few_fields  dividing_Z_S_char_B
#define CLEAR '0'
#define MESSAGES_SIZE 384
#define MINIMUM_COMBO_SIZE 256
#define NOT_RECOGNIZED -1
#define PATH_NAME_SIZE 255
#define QUOTE '"'
#define SET '1'
#define UNBROKEN_BUFFER_SIZE 524288 /* 512 KB */
#include "leaf.h" /* FIELD_COUNT */

/*typedef char* FIELD_POINTER; */
/*typedef FIELD_POINTER (*EDIT_FUNCTION)(FIELD_POINTER p); */

typedef struct DIVIDING DIVIDING;
struct DIVIDING {
    BOOL *selected;
    BOOL allocated, remove_separators;
    char *buffer;
    char *combo;
    char *pattern;
    char messages[MESSAGES_SIZE];
    int buffer_size, field_count, separator;
};

BOOL attempt_to_provide_buffers(DIVIDING *d, BOOL stop);
BOOL full_house_attempt_to_provide_buffers(DIVIDING *d, BOOL stop);
int search_separator(DIVIDING *d, char *p, int beginning);
LEAF *complementing_fields_list(DIVIDING *d, char *p, char *extra, int bond);
LEAF *editing_fields_list(DIVIDING *d, char *p, EDIT_FUNCTION editing, int field_number);
LEAF *mapping_fields_list(DIVIDING *d, char *p);
LEAF *reversing_fields_list(DIVIDING *d, char *p);
LEAF *smashed_to_pieces(DIVIDING *d, char *p);
void dividing_S(DIVIDING *d, int s);
void dividing_S_B(DIVIDING *d, int s, BOOL r);
void dividing_S_char(DIVIDING *d, int s, char f);
void dividing_S_char_B(DIVIDING *d, int s, char f, BOOL r);
void dividing_S_int(DIVIDING *d, int s, int f);
void dividing_S_int_B(DIVIDING *d, int s, int f, BOOL r);
void dividing_Z_S(DIVIDING *d, long z, int s);
void dividing_Z_S_B(DIVIDING *d, long z, int s, BOOL r);
void dividing_Z_S_char(DIVIDING *d, long z, int s, char f);
void dividing_Z_S_char_B(DIVIDING *d, long z, int s, char f, BOOL r);
void dividing_Z_S_int(DIVIDING *d, long z, int s, int f);
void dividing_Z_S_int_B(DIVIDING *d, long z, int s, int f, BOOL r);
void dividing_P_S_char(DIVIDING *d, char *p, int s, char f);
void dividing_P_S_char_B(DIVIDING *d, char *p, int s, char f, BOOL r);
void dividing_P_S_int(DIVIDING *d, char *p, int s, int f);
void dividing_P_S_int_B(DIVIDING *d, char *p, int s, int f, BOOL r);
void dividing_P_Z_S_char(DIVIDING *d, char *p, long z, int s, char f);
void dividing_P_Z_S_char_B(DIVIDING *d, char *p, long z, int s, char f, BOOL r);
void dividing_P_Z_S_int(DIVIDING *d, char *p, long z, int s, int f);
void dividing_P_Z_S_int_B(DIVIDING *d, char *p, long z, int s, int f, BOOL r);
void release_arrays(DIVIDING *d);
void supplying_bits(char *p, int *field_count);
void reverse_unite(DIVIDING *d, char *buffer, char *combo);
void surge_of_set_bits(char *pattern, int field_count, int from, int to);
void unite(DIVIDING *d, char *buffer, char *combo);
void unite_fields(DIVIDING *d, LEAF *left, char *buffer, char *combo);

#endif /* DIVIDING_H */
