#include "kanji_union.h"

void version_guide(double v, BOOL comments) {
    fprintf(stderr, "sjisUTF8 C-%1.2f\n\n", v);

    if(comments) {
        fprintf(stderr, "sjisUTF8 SJIS             # Produce sjisUTF8.txt \n");
        fprintf(stderr, "sjisUTF8 SJIS UTF8        # Produce a new file. \n");
        fprintf(stderr, "sjisUTF8 < SJIS > UTF8    # Every line includes 0Dh. \n");
        fprintf(stderr, "sjisUTF8 -b SJIS          # Produce binary.tmp \n");
        fprintf(stderr, "sjisUTF8 -b SJIS SJIS     # Produce and rename binary.tmp \n");
        fprintf(stderr, "sjisUTF8 -b -y SJIS       # Do not remove binary.tmp \n");
        fprintf(stderr, "sjisUTF8 -CRLF SJIS       # Every line includes 0Dh. \n");
        fprintf(stderr, "sjisUTF8 -CRLF SJIS UTF8  # Every line includes 0Dh. \n");
        fprintf(stderr, "sjisUTF8 -d SJIS          # Do not search a table. \n");
        fprintf(stderr, "sjisUTF8 -LF SJIS         # 0Dh is removed from every line. \n");
        fprintf(stderr, "sjisUTF8 -s SJIS          # Skip control characters except 0Ah. \n");
        fprintf(stderr, "sjisUTF8 -t SJIS UTF8     # SJIS has the same time as UTF8. \n");
        fprintf(stderr, "sjisUTF8 -w SJIS          # -w shows which table sjisUTF8 uses. \n");
        fprintf(stderr, "sjisUTF8 -V               # version \n");
        fprintf(stderr, "sjisUTF8 -VC              # version with comments \n");
    } else {
        fprintf(stderr, "sjisUTF8 SJIS             \n");
        fprintf(stderr, "sjisUTF8 SJIS UTF8        \n");
        fprintf(stderr, "sjisUTF8 < SJIS > UTF8    \n");
        fprintf(stderr, "sjisUTF8 -b SJIS          \n");
        fprintf(stderr, "sjisUTF8 -b SJIS SJIS     \n");
        fprintf(stderr, "sjisUTF8 -b -y SJIS       \n");
        fprintf(stderr, "sjisUTF8 -CRLF SJIS       \n");
        fprintf(stderr, "sjisUTF8 -CRLF SJIS UTF8  \n");
        fprintf(stderr, "sjisUTF8 -d SJIS          \n");
        fprintf(stderr, "sjisUTF8 -LF SJIS         \n");
        fprintf(stderr, "sjisUTF8 -s SJIS          \n");
        fprintf(stderr, "sjisUTF8 -t SJIS UTF8     \n");
        fprintf(stderr, "sjisUTF8 -w SJIS          \n");
        fprintf(stderr, "sjisUTF8 -V               \n");
        fprintf(stderr, "sjisUTF8 -VC              \n");
    }

    exit(1);
}
