CC        = bcc32
LINKER    = ilink32
RC        = brcc32

INCLUDE = -I"C:\borland\bcc55\Include"
LIB     = /L"C:\borland\bcc55\Lib"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap
RFLAGS = -32

TARGET = sjisUTF8.exe
OBJS   = guide.obj dividing.obj leaf.obj path.obj regulate.obj skipping.obj sparse_utf8.obj standard_io.obj sjisutf8main.obj 
RESFILES = sjisUTF8Resource.res

ALL : $(TARGET)

guide.obj: guide.c
	$(CC) $(INCLUDE) -c guide.c
dividing.obj: dividing.c
	$(CC) $(INCLUDE) -c dividing.c
leaf.obj: leaf.c
	$(CC) $(INCLUDE) -c leaf.c
path.obj: path.c
	$(CC) $(INCLUDE) -c path.c
regulate.obj: regulate.c
	$(CC) $(INCLUDE) -c regulate.c
sjisUTF8Resource.res: sjisUTF8Resource.rc
	$(RC) $(RFLAGS) sjisUTF8Resource.rc
skipping.obj: skipping.c
	$(CC) $(INCLUDE) -c skipping.c
sparse_utf8.obj: sparse_UTF8.c
	$(CC) $(INCLUDE) -c sparse_UTF8.c
standard_io.obj: standard_io.c
	$(CC) $(INCLUDE) -c standard_io.c
sjisutf8main.obj: sjisUTF8main.c
	$(CC) $(CFLAGS) $(INCLUDE) -c sjisUTF8main.c

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)
clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
	del *.res
